public class DataSealer {
    // This class is used to "seal" a sequence of values.   "Sealing" protects the
    //     confidentiality of a value, so that the only way to recover the initial value is to
    //     "unseal" the value using the same key that was used to seal it.   At the same time,
    //     "sealing" protects the integrity of a value, so that a party unsealing the value using
    //     the same key (that was used to seal it) can verify that nobody has tampered with the
    //     value since it was sealed.
    // If a Sealer is used to seal a sequence of values, then those values should be unsealed
    //     by a single Unsealer, in the same order that they were sealed.   If such 
    //     values are unsealed in a different order, or by more than one Unsealer, errors will
    //     result (as described in the Unsealer class).

    public static final int KEY_SIZE_BYTES = -1;   // IMPLEMENT THIS
    public static final int KEY_SIZE_BITS = KEY_SIZE_BYTES*8;

    public DataSealer(byte[] key) {
    assert key.length == KEY_SIZE_BYTES;

    // IMPLEMENT THIS
    }

    public byte[] seal(byte[] in) {
    // Seals the contents of <in> so that its confidentiality and 
    //    integrity are protected against would-be attackers who do 
    //    not know the key that was used to initialize this DataSealer.
    // This returns a newly allocated byte[] containing the sealed value.

    return null;   // IMPLEMENT THIS
    }
}