public class DataUnsealer {
    // This class is used to "unseal" a sequence of values that were "sealed" by a DataSealer.
    // If a DataSealer is used to seal a sequence of values, then those values should be unsealed
    //     by a single DataUnsealer, in the same order that they were sealed. 

    public static final int KEY_SIZE_BYTES = DataSealer.KEY_SIZE_BYTES;
    public static final int KEY_SIZE_BITS = DataSealer.KEY_SIZE_BITS;

    public DataUnsealer(byte[] key) {
    assert key.length == KEY_SIZE_BYTES;

    // IMPLEMENT THIS
    }

    public byte[] unseal(byte[] in) {
    // Unseals the contents of <in>.  The value passed in will normally
    //    have been created by calling seal() in a DataSealer that was
    //    initialized with the same key as this DataUnsealer.
    //  If the integrity of the sealed value cannot be verified, or if
        //    the sealed value is out of sequence (i.e., it was not the next
        //    value sealed by the corresponding DataSealer), then this method
        //    returns null.   Otherwise it returns a newly allocated 
        //    byte-array containing the value that was originally 
    //    passed to seal().
        //  If this method ever returns null, then all subsequent calls to 
        //    this method must also return null--something unexpected has gone 
        //    wrong, and we must always return null in the future, just to be safe.

    return null;   // IMPLEMENT THIS
    }
}