import java.util.Random;

public class PRGen extends Random {
    // This implements a pseudorandom generator.  It extends java.util.Random, which provides
    //     a useful set of utility methods that all build on next(.).  See the documentation for
    //     java.util.Random for an explanation of what next(.) is supposed to do.
    // If you're calling a PRGen, you probably want to call methods of the Random superclass.
    //
    // There are two requirements on a pseudorandom generator.  First, it must be pseudorandom,
    //     meaning that there is no (known) way to distinguish its output from that of a
    //     truly random generator, unless you know the key.  Second, it must be deterministic, 
    //     which means that if two programs create generators with the same seed, and then
    //     the two programs make the same sequence of calls to their generators, they should
    //     receive the same return values from all of those calls.
    // Your generator must have an additional property: forward security.  This means that if an
    //     adversary is able to observe the full state of the generator at some point in time, that
    //     adversary cannot reconstruct any of the output that was produced by previous calls to the
    //     generator.

    public static final int KEY_SIZE_BYTES = -1;   // IMPLEMENT THIS
    public static final int KEY_SIZE_BITS = KEY_SIZE_BYTES*8;

    public PRGen(byte[] key) {
    super();
    assert key.length == KEY_SIZE_BYTES;

    // IMPLEMENT THIS
    }

    protected int next(int bits) {
    // For description of what this is supposed to do, see the documentation for 
        //      java.util.Random, which we are subclassing.

    return 0;   // IMPLEMENT THIS
    }
}