
import java.security.SecureRandom;


public class TrueRandomness {
    public static final int NUM_BYTES = 32;

    private static boolean alreadyUsed = false;

    public static byte[] get() {
    // Provides <NUM_BYTES> bytes of (assumed to be) random data
    // This can only be called once; assertion will fail if called again

    if (alreadyUsed)
        throw new RuntimeException("TrueRandomness .get() has already been used.");

    byte[] ret = new byte[NUM_BYTES];
    SecureRandom sr = new SecureRandom();
    sr.nextBytes(ret);
    alreadyUsed = true;
    return ret;
    }
}
